<?php

class Helper {

	public static function reboot($url) {
		/* 2 verschiedene Prozesse werden gestartet
		 * der erste Prozess führt ein rcK aus,
		 * der zweite Prozess wartet 10 Sekunden und wenn der rcK Prozess
		 * nicht richtig beendet wurde, wird diese gestoppt und die Karte wird
		 * neugestartet. Per AJAX wird geprüft ob die Karte wieder UP ist, das
		 * Anmeldungfenster wird dann wieder angezeigt.
		 */
		$handle = popen('/bin/sh /etc/init.d/rcK', 'r');
		$i = 0;
		while (!feof($handle) && $i++ != 10) {
			sleep(1);
		}
		pclose($handle);
		print("<script type='text/javascript'>
			window.setTimeout('setRequest()',5000);
                    </script>");
		exec('/usr/bin/killall rcK');
		flush();
		exec('/sbin/reboot');
		exit();
		/* $pid = pcntl_fork();

		  if($pid) {
		  // this is the parent process
		  // wait until the child has finished processing then end the script
		  sleep(10);
		  print("<script type='text/javascript'>
		  window.setTimeout('setRequest()',5000);
		  </script>");
		  exec('/usr/bin/killall rcK');
		  exec ('/sbin/reboot');
		  exit;
		  }
		  // the child process runs its stuff here and then ends
		  $ba= new beroAri();
		  $ba->set("trace","no");
		  exec('/bin/sh /etc/init.d/rcK'); */
	}

	/* Funktion für das Löschen eines Moduls und der entsprechenden Dialplaneinträge,
	 * wenn die Belegung der Line Interfaces sich ändert
	 */

	public static function deleteModul($li, $name, $table) {
		//echo $li.$name.$table;
		$ba = new beroAri();


		//CAS channels und Dialplan Einträge löschen löschen.
		if ($table == "cas") {
			$query = $ba->select("select port from $table where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");
			while ($entry = $ba->fetch_array($query)) {
				$query = $ba->select("select * from cas_channels where port='" . $entry['port'] . "'");
				while ($ent = $ba->fetch_array($query)) {
					$ba->delete("delete from dialplan where fromDirection='" . sqlite_escape_string($table) . "' and fromId='g:" . $ent['gr'] . "'");
					$ba->delete("delete from dialplan where fromDirection='" . sqlite_escape_string($table) . "' and fromId='" . $ent['channel'] . "'");
					$ba->delete("delete from dialplan where toDirection='" . sqlite_escape_string($table) . "' and toId='g:" . $ent['gr'] . "'");
					$ba->delete("delete from dialplan where toDirection='" . sqlite_escape_string($table) . "' and toId='" . $ent['channel'] . "'");
				}
				$ba->delete("delete from cas_channels where port='" . $entry["port"] . "'");
			}
			//Dialplan Einträge aller anderen Technologien löschen
		} else {
			$query = $ba->select("select * from " . sqlite_escape_string($table) . " where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");
			while ($entry = $ba->fetch_array($query)) {
				$ba->delete("delete from dialplan where fromDirection='$table' and fromId='g:" . $entry['gr'] . "'");
				$ba->delete("delete from dialplan where fromDirection='$table' and fromId='" . $entry['port'] . "'");
				$ba->delete("delete from dialplan where toDirection='$table' and toId='g:" . $entry['gr'] . "'");
				$ba->delete("delete from dialplan where toDirection='$table' and toId='" . $entry['port'] . "'");
			}
		}
		$ba->delete("delete from " . sqlite_escape_string($table) . " where lif='" . sqlite_escape_string($li) . "' and type='" . sqlite_escape_string($name) . "'");


		$ba->set('portswitch', 0);

		$q = $ba->select("SELECT type, lif FROM isdn union SELECT type, lif FROM analog union SELECT type, lif FROM gsm order by lif");
		$i = 0;
		while ($ent = $ba->fetch_array($q)) {
			$lif[$i] = $ent['lif'];
			$type[$i] = $ent['type'];
			$i++;
		}

		$res = file_get_contents('/proc/cmdline');
		preg_match("/.*revision=(?<revision>.*)/", $res, $revision);
		$revision = $revision['revision'];
		if (($type[0] == "bf4S0" || $type[0] == "bf2S02FXS" || $type[0] == "bf4FXS" || $type[0] == "bf4FXO") && !isset($type[1]) && $revision != "1.80" && $revision != "1.8") {
			$ba->set('portswitch', 1);
		}

		$option = $ba->get("activate");
		if ($option <= 3)
			$query = $ba->set('activate', '3');
		echo "<script>aktivieren(1,'state','3','" . ACTIVATE . "');</script>";
	}

	/* Funktion für das Löschen einer Call progress table,
	 * wenn die Belegung der Line Interfaces sich ändert
	 */

	public static function deleteCPT($dir) {
		//echo $li.$name.$table;
		$ba = new beroAri();
		$query = $ba->select("select * from callprogress where direction='" . sqlite_escape_string($dir) . "'");
		while ($entry = $ba->fetch_array($query)) {
			$ba->delete("delete from callprogress_entries where id_name='" . $entry['id'] . "'");
		}
		$ba->delete("delete from callprogress where direction='" . sqlite_escape_string($dir) . "'");
	}

	/* Funktion für das Erstellen eines Moduls
	 */

	public static function createModul($setPortSwitch = false) {

		$ba = new beroAri();

		if ($setPortSwitch == true)
			$ba->set("portswitch", 0);
		$queries_li1 = $ba->add_module_db(1, 0, 0);

		if (!empty($queries_li1)) {
			foreach ($queries_li1 as $query) {
				$ba->exec_query($query);
			}
			unset($queries_li1);
		}

		if ($ba->is_error()) {
			echo '<script>alert(\'' . $ba->error() . '\');</script>';
		}

		$option = $ba->get("activate");
		if ($option <= 3)
			$query = $ba->set('activate', '3');
	}

	public static function getIsdnPorts() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		//ISDN Ports suchen
		$qu = $ba->select("select port from isdn");
		$result = array();
		while ($entry = $ba->fetch_array($qu)) {
			array_push($result, $entry['port']);
		}
		//Array zurückgeben
		return $result;
	}

	/*
	 * Activate button anzeigen
	 */

	public static function activate($option, $show = false, $m = "", $text = "activate") {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		//ISDN Ports suchen
		$optionSaved = $ba->get("activate");
		if ($optionSaved <= $option) {
			$query = $ba->set('activate', $option);
			if ($show)
				return "<script>aktivieren(1,'" . $m . "','" . $option . "','" . $text . "','" . $_GET['opt'] . "');</script>";
		}
	}
	/*
	 * Activate option der API speichern
	 */

	public static function activateApi($option) {
		file_put_contents("/tmp/apioption", $option);
		$ba = new beroAri();
		$ba->set('activate', $option);
	}

	/*
	 * Gibt die activate option zurück
	 */

	public static function getActivateOption() {
		$ba = new beroAri();
		return $ba->get("activate");
	}

	/* Gibt zurück die Bezeichnung einen Line interface
	 */

	public static function getLiName($name) {
		if ($name == "xhfc-4su")
			return 'bf4S0';
		if ($name == "xhfc-2su")
			return 'bf2S0';
		if ($name=="xhfc-1su") 
			return 'bf1S0';
		if ($name == "hfc-e1")
			return 'bf1E1';
		if ($name == "hfc-2e1")
			return 'bf2E1';
		if ($name == "telit-2GSM")
			return 'bf2GSM';
		if ($name == "telit-1GSM")
			return 'bf1GSM';
		if ($name == "si-4fxs")
			return 'bf4FXS';
		if ($name == "si-8fxs")
			return 'bf8FXS';
		if ($name == "si-4fxo")
			return 'bf4FXO';
		if ($name == "si-1fxs")
			return 'bf1FXS';
		if ($name == "si-2fxo")
			return 'bf2FXO';
		if ($name == "falc-1t1e1")
			return 'bf1t1e1';
		if ($name == "falc-2t1e1")
			return 'bf2t1e1';
		if ($name == "falc-4t1e1")
			return 'bf4t1e1';
		if ($name == "xhfcSi-2s02fxs")
			return 'bf2S02FXS';
		if ($name == "unknown")
			return 'none';
	}

	public static function getCountrySetting($c = "1TR110_DE") {
		$country = array(
			"FCC" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 1, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"TRB21" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ARGENTINA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"AUSTRALIA" => array('ohs' => 1, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0x3'),
			"AUSTRIA" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"BAHRAIN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"BELGIUM" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"BRAZIL" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0x0'),
			"BULGARIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"CANADA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CHILE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CHINA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x0', 'mini' => "0x3", 'ilim' => 0, 'acim' => '0xf'),
			"COLOMBIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"CROATIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"CYPRUS" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"CZECH" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"DENMARK" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ECUADOR" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"EGYPT" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"ELSALVADOR" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"FINLAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"FRANCE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"GERMANY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"1TR110_DE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 1, "rt2" => 1, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x3'),
			"GREECE" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"GUAM" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"HONGKONG" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"HUNGARY" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"ICELAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"INDIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x4'),
			"INDONESIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"IRELAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ISRAEL" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ITALY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"JAPAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"JORDAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"KAZAKHSTAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"KUWAIT" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"LATVIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"LEBANON" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"LUXEMBOURG" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"MACAO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MALAYSIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MALTA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"MEXICO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"MOROCCO" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NETHERLANDS" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NEWZEALAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x4'),
			"NIGERIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"NORWAY" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"OMAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PAKISTAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PERU" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PHILIPPINES" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"POLAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 1, "rt" => 1, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"PORTUGAL" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"ROMANIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"RUSSIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SAUDIARABIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SINGAPORE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SLOVAKIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x3'),
			"SLOVENIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x2'),
			"SOUTHAFRICA" => array('ohs' => 1, 'ohs2' => 0, 'rz' => 1, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x3'),
			"SOUTHKOREA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"SPAIN" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SWEDEN" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SWITZERLAND" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x2'),
			"SYRIA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"TAIWAN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"THAILAND" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"UAE" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"UK" => array('ohs' => 0, 'ohs2' => 1, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 1, 'acim' => '0x5'),
			"USA" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
			"YEMEN" => array('ohs' => 0, 'ohs2' => 0, 'rz' => 0, "rt" => 0, "rt2" => 0, 'dcv' => '0x3', 'mini' => "0x0", 'ilim' => 0, 'acim' => '0x0'),
		);
		return $country[$c];
	}

	public static function getInfo() {
		require_once '/usr/fallback/beroConf.php';
		$bc = new beroConf('root');
		$info = array();
		//Serial
		$res = file_get_contents('/proc/cmdline');
		preg_match("/carduuid=([0-9-]*)/", $res, $serial);
		$info['serial'] = $serial[1];
		//Root FS Version
		$f = @file("/VERSION");
		$tmp = explode("=", $f[1]);
		$info['rootfs'] = $tmp[1];

		//FPGA Version
		$info['fpga'] = file_get_contents("/proc/FPGA_VERSION");
		//HW Revision
		$res = file_get_contents('/proc/cmdline');
		preg_match("/.*revision=(?<revision>.*)/", $res, $revision);
		$info['hw_revision'] = $revision['revision'];

		//App FS Version
		$info['appfs'] = $bc->get("root", "app-image");

		//MAC Address
		exec('/sbin/ifconfig eth0 | /bin/grep HWaddr', $resm);
		preg_match("/[^a-zA-Z0-9:]*? HWaddr (?<mac>.+)/", $resm[0], $mac);
		$info['mac'] = $mac[mac];

		//Network Config
		// Netzwerk Konfiguration
		if ($bc->get("root", "vlan-enable") == 1) {
			$info['ip'] = exec('/sbin/ifconfig eth0.' . $bc->get("root", "vlan-id") . ' | sed -ne "s/.*inet addr:\(.*\) Bcast.*/\1/p"');
			$info['mask'] = exec('/sbin/ifconfig eth0.' . $bc->get("root", "vlan-id") . ' | sed -ne "s/.*Mask:\(.*\)/\1/p"');
		} else {
			$info['ip'] = exec('/sbin/ifconfig eth0 | sed -ne "s/.*inet addr:\(.*\) Bcast.*/\1/p"');
			$info['mask'] = exec('/sbin/ifconfig eth0 | sed -ne "s/.*Mask:\(.*\)/\1/p"');
		}
		$info['gateway'] = exec('/sbin/route -n | sed -ne "s/^0\.0\.0\.0[[:blank:]]*\([\.0-9]*\) .*/\1/p"');

		$tmp = file('/etc/resolv.conf');
		foreach ($tmp as $line) {
			if (strstr($line, 'nameserver')) {
				$nameserver[] = trim(substr($line, 10));
			}
		}
		unset($tmp);
		$info['dns'] = ((strlen($nameserver[0]) != 0) ? $nameserver[0] : '0.0.0.0');
		$info['secondary_dns'] = ((strlen($nameserver[1]) != 0) ? $nameserver[1] : '0.0.0.0');

		//Date and time
		$info['date'] = exec("date  +%d-%B-%Y-%H:%M:%S");
		//Lif
		$lif = array(0, 1);
		foreach ($lif as $li) {
			$ba = new beroAri();
			$query = $ba->select('SELECT type FROM isdn WHERE lif="' . $li . '" union SELECT type FROM analog WHERE lif="' . $li . '" union SELECT type FROM gsm WHERE lif="' . $li . '" union SELECT type FROM cas WHERE lif="' . $li . '"');
			$type = sqlite_fetch_single($query);
			if ($type != "")
				$info['lif' . $li] = "li" . $li . ":  " . $type;
		}

		//ISGW Uptime
		require_once ('/usr/local/www/berogui/includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$isgw->isgw_login();
		$isgw_uptime = $isgw->isgw_uptime();
		$isgw_uptime = preg_split("/: /", $isgw_uptime);
		$info['isgw_uptime'] = $isgw_uptime[1];
		//System Uptime
		exec('/usr/bin/uptime', $resup);
		preg_match("/(?<t>.+), load /", $resup[0], $uptime);
		$info['system_uptime'] = $uptime[t];
		$info['sip2sip_license_status'] = $isgw->isgw_siplicensestate();
		$info['sip2sip_number_of_licenses'] = $isgw->isgw_siplicensecount();

		//MSP Firmware
		$msp = explode(':', $isgw->Query('fw'));
		$info['msp_fw'] = $msp[1];


		return $info;
	}

	static public function getTotalCalls() {
		require_once ('/usr/local/www/berogui/includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$result = $isgw->isgw_login();
		if ($result == false) {
			return 0;
		}
		$channelresult = $isgw->isgw_channelstate();
		$rows = explode("\n", $channelresult);
		$i = 0;
		$dontUse = array();
		foreach ($rows as $row) {
			$row = htmlspecialchars($row);
			$values = explode("\t", $row);
			if (trim($row) != "" && strpos($row, "LISTING CALL OPERATIONS COMPACT") === false && (!in_array(intval($values[0]), $dontUse))) {
				if (strpos($values[13], "MSP_BRIDGED") !== false) {
					/**
					 * PSTN zu PSTN Einträgen
					 */
					$tmp = explode("=", $values[10]);
					array_push($dontUse, intval($tmp[1]));
					$i++;
				} else {
					$i++;
				}
			}
		}
		return $i;
	}

	static public function getAppList() {
		$ret = array();
		if (!(file_exists('/home/admin/apps/')) || !($dh = opendir('/home/admin/apps/'))) {
			return $ret;
		}

		while (($file = readdir($dh)) !== false) {
			if (($file == '.') || ($file == '..')) {
				continue;
			}
			$ret[] = $file;
		}
		closedir($dh);

		return $ret;
	}
	
	static public function getConfigFromIsgw(){
		exec("/usr/local/bin/isgw -C -e/usr/conf",$lines);
		reset($lines);
		while (strpos(current($lines),"Default call configuration:")===FALSE && current($lines)!==FALSE){
			array_shift($lines);
		}
		array_shift($lines);
		return $lines;
	}


	static public function getDefaultConfig(){
		
		$lines = self::getConfigFromIsgw();
		$default=array();
		foreach ($lines as $line){
			preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $line, $res);
			$default[$res["name"]]=$res['def'];
		}
		return  $default;		
	}

}

?>
